/***************************************************************************
                          actionmanager.h  -  action manager header
                             -------------------
    begin                : Sun Dec 22 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__ACTIONMANAGER_H
#define INCLUDED__ACTIONMANAGER_H
 
#include <vector>

#include "actionobject.h"

using namespace std;

// Internal struct used by
struct actionhandler {
  const char *actionname;
  ActionObject *aobject;
};

// Main action manager object
class ActionManager {
  public:
    ActionManager(void);
    virtual ~ActionManager(void);
    int RegisterLocalAction(const char *actionname, ActionObject *aobject);
    int RegisterGlobalAction(const char *actionname, ActionObject *aobject);
    void UnregisterLocalAction(const char *actionname, ActionObject *aobject);
    void UnregisterGlobalAction(const char *actionname, ActionObject *aobject);
    void UnregisterObjectActions(ActionObject *aobject);
    int ExecuteAction(const char *action);
  private:
    vector<actionhandler *> globalhandlers;
    vector<actionhandler *> localhandlers;
};

// Function prototypes

const char *GetUserAction(const char *actionname);

#endif
