/***************************************************************************
                          conf.h  -  configuration definitions
                             -------------------
    begin                : Sat Nov 30 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__CONF_H
#define INCLUDED__CONF_H
 
#include "SDL.h"

// Struct defs

struct keybinding {
  SDLKey key;
  SDLMod mod;
  char *action;
};

const struct {
  char *keystr;
  SDLKey key;
} keynamelist[] = {
  {"backspace", SDLK_BACKSPACE},
  {"tab", SDLK_TAB},
//  {"clear", SDLK_CLEAR
  {"enter", SDLK_RETURN},
  {"pause", SDLK_PAUSE},
  {"escape", SDLK_ESCAPE},
  {"space", SDLK_SPACE},
//SDLK_EXCLAIM
//SDLK_QUOTEDBL
//SDLK_HASH
//SDLK_DOLLAR
//SDLK_AMPERSAND
  {"quote", SDLK_QUOTE},
//SDLK_LEFTPAREN
//SDLK_RIGHTPAREN
//SDLK_ASTERISK},
//SDLK_PLUS
  {"comma", SDLK_COMMA},
  {"minus", SDLK_MINUS},
  {"dot", SDLK_PERIOD},
  {"slash", SDLK_SLASH},
  {"0", SDLK_0},
  {"1", SDLK_1},
  {"2", SDLK_2},
  {"3", SDLK_3},
  {"4", SDLK_4},
  {"5", SDLK_5},
  {"6", SDLK_6},
  {"7", SDLK_7},
  {"8", SDLK_8},
  {"9", SDLK_9},
  {"semicolon", SDLK_SEMICOLON},
//SDLK_LESS
  {"equals", SDLK_EQUALS},
//SDLK_GREATER
//SDLK_QUESTION
//SDLK_AT
  {"leftbracket", SDLK_LEFTBRACKET},
  {"backslash", SDLK_BACKSLASH},
  {"rightbracket", SDLK_RIGHTBRACKET},
// SDLK_CARET
// SDLK_UNDERSCORE
  {"backquote", SDLK_BACKQUOTE},
  {"a", SDLK_a},
  {"b", SDLK_b},
  {"c", SDLK_c},
  {"d", SDLK_d},
  {"e", SDLK_e},
  {"f", SDLK_f},
  {"g", SDLK_g},
  {"h", SDLK_h},
  {"i", SDLK_i},
  {"j", SDLK_j},
  {"k", SDLK_k},
  {"l", SDLK_l},
  {"m", SDLK_m},
  {"n", SDLK_n},
  {"o", SDLK_o},
  {"p", SDLK_p},
  {"q", SDLK_q},
  {"r", SDLK_r},
  {"s", SDLK_s},
  {"t", SDLK_t},
  {"u", SDLK_u},
  {"v", SDLK_v},
  {"w", SDLK_w},
  {"x", SDLK_x},
  {"y", SDLK_y},
  {"z", SDLK_z},
  {"delete", SDLK_DELETE},
  {"keypad0", SDLK_KP0},
  {"keypad1", SDLK_KP1},
  {"keypad2", SDLK_KP2},
  {"keypad3", SDLK_KP3},
  {"keypad4", SDLK_KP4},
  {"keypad5", SDLK_KP5},
  {"keypad6", SDLK_KP6},
  {"keypad7", SDLK_KP7},
  {"keypad8", SDLK_KP8},
  {"keypad9", SDLK_KP9},
  {"keypaddot", SDLK_KP_PERIOD},
  {"keypadslash", SDLK_KP_DIVIDE},
  {"keypadstar", SDLK_KP_MULTIPLY},
  {"keypadminus", SDLK_KP_MINUS},
  {"keypadplus", SDLK_KP_PLUS},
  {"keypadenter", SDLK_KP_ENTER},
  {"keypadequals", SDLK_KP_EQUALS},
  {"uparrow", SDLK_UP},
  {"downarrow", SDLK_DOWN},
  {"rightarrow", SDLK_RIGHT},
  {"leftarrow", SDLK_LEFT},
  {"insert", SDLK_INSERT},
  {"home", SDLK_HOME},
  {"end", SDLK_END},
  {"pageup", SDLK_PAGEUP},
  {"pagedown", SDLK_PAGEDOWN},
  {"f1", SDLK_F1},
  {"f2", SDLK_F2},
  {"f3", SDLK_F3},
  {"f4", SDLK_F4},
  {"f5", SDLK_F5},
  {"f6", SDLK_F6},
  {"f7", SDLK_F7},
  {"f8", SDLK_F8},
  {"f9", SDLK_F9},
  {"f10", SDLK_F10},
  {"f11", SDLK_F11},
  {"f12", SDLK_F12},
  {"f13", SDLK_F13},
  {"f14", SDLK_F14},
  {"f15", SDLK_F15},
  {"numlock", SDLK_NUMLOCK},
  {"capslock", SDLK_CAPSLOCK},
  {"scrolllock", SDLK_SCROLLOCK},
  {"rshift", SDLK_RSHIFT},
  {"lshift", SDLK_LSHIFT},
  {"rctrl", SDLK_RCTRL},
  {"lctrl", SDLK_LCTRL},
  {"ralt", SDLK_RALT},
  {"lalt", SDLK_LALT},
//  {"", SDLK_RMETA
//  {"", SDLK_LMETA
  {"lwin", SDLK_LSUPER},
  {"rwin", SDLK_RSUPER},
//  {"", SDLK_MODE
//  {"", SDLK_HELP
  {"printscreen", SDLK_PRINT},
//  {"sysreq", SDLK_SYSREQ},
//  {"", SDLK_BREAK
  {"menu", SDLK_MENU},
//  {"", SDLK_POWER
  {NULL, SDLK_BACKSPACE} // doesn't matter what key you have here, NULL marks end of list
};

// Modifier types
enum {
  MODKEY_NONE     = 0x0,    // strictly no modifier keys pressed
  MODKEY_LSHIFT   = 0x1,    // left shift
  MODKEY_RSHIFT   = 0x2,    // right shift
  MODKEY_SHIFTMASK = MODKEY_LSHIFT | MODKEY_RSHIFT,  // both left & right shift
  MODKEY_SHIFT    = 0x4,    // either shift
  MODKEY_LCTRL    = 0x8,    // etc...
  MODKEY_RCTRL    = 0x10,
  MODKEY_CTRLMASK = MODKEY_LCTRL | MODKEY_RCTRL,
  MODKEY_CTRL     = 0x20,
  MODKEY_LALT     = 0x40,
  MODKEY_RALT     = 0x80,
  MODKEY_ALTMASK  = MODKEY_LALT | MODKEY_RALT,
  MODKEY_ALT      = 0x100,

  // FIXME: Lock keys are ignored right now (difficult to handle)
  MODKEY_NUMLOCK  = 0x1000,
  MODKEY_CAPSLOCK = 0x2000,
  MODKEY_LOCKMASK = MODKEY_NUMLOCK | MODKEY_CAPSLOCK,

  MODKEY_ANYLOCK  = 0x100000,   // don't care about lock status but do care about other modifiers
  MODKEY_ANY      = 0x200000    // don't care what modifiers are pressed
};

// SDL modifier key to eboxy code map
const struct {
  SDLMod sdlmod;
  int modcode;
} modmap[] = {
  {KMOD_LSHIFT, MODKEY_LSHIFT},
  {KMOD_RSHIFT, MODKEY_RSHIFT},
  {KMOD_LCTRL,  MODKEY_LCTRL},
  {KMOD_RCTRL,  MODKEY_RCTRL},
  {KMOD_LALT,   MODKEY_LALT},
  {KMOD_RALT,   MODKEY_RALT},
  {KMOD_CAPS,   MODKEY_CAPSLOCK},
  {KMOD_NUM,    MODKEY_NUMLOCK},
  {KMOD_NONE,   MODKEY_NONE}
};

// Modifier key string to constant map
const struct {
  char *modstr;
  int mod;
} modkeynamelist[] = {
  {"lshift",   MODKEY_LSHIFT},
  {"rshift",   MODKEY_RSHIFT},
  {"shift",    MODKEY_SHIFT},
  {"lctrl",    MODKEY_LCTRL},
  {"rctrl",    MODKEY_RCTRL},
  {"ctrl",     MODKEY_CTRL},
  {"lalt",     MODKEY_LALT},
  {"ralt",     MODKEY_RALT},
  {"alt",      MODKEY_ALT},
  // FIXME: Lock keys are ignored right now (difficult to handle)
//  {"numlock",  MODKEY_NUMLOCK},
//  {"capslock", MODKEY_CAPSLOCK},
//  {"anylock",  MODKEY_ANYLOCK},
  {"any",      MODKEY_ANY},
  {"none",     MODKEY_NONE},
  {NULL, MODKEY_NONE} // doesn't matter what key you have here, NULL marks end of list
};

// Characters (other than alphanumerics) that can be entered into textfields
const struct {
  char *charname;
  char charchr;
} textinputchars[] = {
  {"exclamation",  '!'},
  {"at",           '@'},
  {"hash",         '#'},
  {"dollar",       '$'},
  {"percent",      '%'},
  {"caret",        '^'},
  {"ampersand",    '&'},
  {"star",         '*'},
  {"openbracket",  '('},
  {"closebracket", ')'},
  {"underscore",   '_'},
  {"minus",        '-'},
  {"plus",         '+'},
  {"equals",       '='},
  {"opensquarebracket",  '['},
  {"closesquarebracket", ']'},
  {"openbrace",    '{'},
  {"closebrace",   '}'},
  {"pipe",         '|'},
  {"backslash",    '\\'},
  {"colon",        ':'},
  {"semicolon",    ';'},
  {"quote",        '\''},
  {"doublequote",  '\"'},
  {"slash",        '/'},
  {"question",     '?'},
  {"lessthan",     '<'},
  {"greaterthan",  '>'},
  {"comma",        ','},
  {"dot",          '.'},
  {"tilde",        '~'},
  {"backquote",    '`'},
  {"space",        ' '},
  {NULL,           '\0'}  // end of list
};

// Function Prototypes

int readKeyConf(void);
int writeKeyConf(const char *conffile);
void useDefaultBindings(void);

char textInputNameToChar(const char *charname);
const char *textInputCharToName(char c);
const char *keyToName(SDLKey key);

bool checkmodkeys(SDLMod pressedmod, int expectedmod);
int transmod(SDLMod mod);

#endif
