/***************************************************************************
                          customobject.h  -  eboxy custom object
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__CUSTOMOBJECT_H
#define INCLUDED__CUSTOMOBJECT_H
 
#include "types.h"
#include "dynamicobject.h"
#include "functionproperty.h"
 
using namespace std;
 
class ebCustomObject: public ebDynamicObject {
  public:
    ebCustomObject(const char *name);
    virtual ~ebCustomObject(void);
    int AddProperty(const char *name, const char *(*getter)(const char *), void (*setter)(const char *, const char *));
    int AddProperty(const char *name, propertygetfn getter, propertysetfn setter, bool required = false);
    int AddMethod(const char *name, int numargs, methodfn methodfuncex);
    virtual const char *GetPropertyValue(const char *property);
    virtual void SetPropertyValue(const char *property, const char *value);
    virtual bool HasProperty(const char *property);
    CustomProperty *GetProperty(int index);
    const char *GetDefaultProperty(void);
    int GetPropertyCount(void);
    CustomProperty *FindProperty(const char *name);
    int FireEvent(const char *event);
    int FireEventWait(const char *event);

    friend const char *CustomObject_GetName(ebCustomObject *sender);
    friend const char *CustomObject_GetType(ebCustomObject *sender);
    friend const char *CustomObject_GetPropertyCount(ebCustomObject *sender);
    friend const char *CustomObject_GetMethodCount(ebCustomObject *sender);
    friend const char *CustomObject_GetEventCount(ebCustomObject *sender);

    friend const char *CustomObject_GetProperty(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
    friend const char *CustomObject_GetMethod(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
    friend const char *CustomObject_GetEvent(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
  protected:
    CustomProperty *defaultproperty;
  private:
    vector<CustomProperty *> properties;
};

#endif
