/***************************************************************************
           externalmethodhandler.cpp  -  method handler for plugins
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>

#include "externalmethodhandler.h"

using namespace std;

ExternalMethodHandler::ExternalMethodHandler(const char *name, ebObject *owner, int numargs, const char *(*methodfuncex)(const char *, int, const char *[]))
: MethodHandler(name, owner, numargs) {
  this->methodfuncex = methodfuncex;
}

const char *ExternalMethodHandler::Call(int numargs, const char *args[]) {
  if(numargs == this->numargs)
    return methodfuncex(owner->GetName(), numargs, args);
  else {
    cerr << "Wrong number of arguments passed to method " << name << " of object " << owner->GetName();
    cerr << "(" << this->numargs << "expected, " << numargs <<  " supplied)" << endl;
  }
  return "";
}
