/***************************************************************************
  functionproperty.cpp  -  property object that uses getter/setter functions
                             -------------------
    begin                : Sun Sep 8 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include <cstring>
#include <cstdlib>

#include "functionproperty.h"

using namespace std;

// FIXME: this class needs to be renamed to FunctionProperty

ebCustomProperty::ebCustomProperty(const char *name, const char *(*getter)(const char *), void (*setter)(const char *, const char *))
: CustomProperty(name) {
  this->getter = getter;
  this->setter = setter;
}

void ebCustomProperty::SetValue(const char *value) {
  if(setter)
    setter(name, value);
  else
    cerr << "Property " << name << " is read-only" << endl;
}

const char *ebCustomProperty::GetValue(void) {
  if(getter)
    return getter(name);
  else {
    cerr << "Property " << name << " is write-only" << endl;
    return NULL;
  }
}
