/***************************************************************************
                 gui_utils.cpp  -  SDL_gui extention utility functions
                             -------------------
    begin                : Tue Nov 19 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <cstring>
#include <cstdlib>

#include "SDL_gui.h"
#include "gui_extensions.h"

using namespace std;

void DrawClipped(GUI_Surface *source, GUI_Drawable *dest, SDL_Rect destarea, int destx, int desty)
{
  SDL_Rect dr;
	SDL_Rect sr;
  			
	sr.w = dr.w = source->GetWidth();
	sr.h = dr.h = source->GetHeight();
	sr.x = sr.y = 0;
  			
	dr.x = destx;
	dr.y = desty;

	if (GUI_ClipRect(&sr, &dr, &destarea))
		dest->Draw(source, &sr, &dr);
}

int stylestrtoint(const char *style) {
  if(!strcasecmp(style, "tiled"))
    return IMAGESTYLE_TILED;
  else
    return IMAGESTYLE_NORMAL;
}

const char *styleinttostr(int style) {
  if(style == IMAGESTYLE_TILED)
    return "tiled";
  else
    return "normal";
}

int autostrtoint(const char *autostr) {
  if(!strcasecmp(autostr, "on"))
    return AUTOPROPERTY_ON;
  else if(!strcasecmp(autostr, "off"))
    return AUTOPROPERTY_OFF;
  else
    return AUTOPROPERTY_AUTO;
}

const char *autointtostr(int autovalue) {
  if(autovalue == AUTOPROPERTY_ON)
    return "on";
  else if(autovalue == AUTOPROPERTY_OFF)
    return "off";
  else
    return "auto";
}

int textalignstrtoint(const char *str) {
  if(strcasecmp(str, "center") ==0 || strcasecmp(str, "centre") ==0 || strcasecmp(str, "middle") ==0)
    return WIDGET_HORIZ_CENTER | WIDGET_VERT_TOP;
  else if(strcasecmp(str, "right") ==0)
    return WIDGET_HORIZ_RIGHT | WIDGET_VERT_TOP;
  else // left
    return WIDGET_HORIZ_LEFT | WIDGET_VERT_TOP;
}

const char *textaligninttostr(int align) {
  if(align & WIDGET_VERT_TOP) {
    if(align & WIDGET_HORIZ_LEFT)
      return "left";
    else if(align & WIDGET_HORIZ_RIGHT)
      return "right";
    else
      return "center";
  }
  return "";
}

unsigned int colortouint(SDL_Color c) {
  unsigned int cval = 0xFF000000;

  cval = cval | (c.r * 0x10000);
  cval = cval | (c.g * 0x100);
  cval = cval | (c.b);

  return cval;
}
