/***************************************************************************
  internalfunctionproperty.cpp - property object that uses getter/setter functions
                             -------------------
    begin                : Tue May 6 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include <cstring>
#include <cstdlib>

#include "internalfunctionproperty.h"

using namespace std;
                          
InternalFunctionProperty::InternalFunctionProperty(const char *name, ebCustomObject *object, propertygetfn getter, propertysetfn setter, bool required)
: CustomProperty(name) {
  this->getter = getter;
  this->setter = setter;
  this->object = object;
  this->required = required;
}

void InternalFunctionProperty::SetValue(const char *value) {
  if(setter)
    setter(object, value);
  else
    cerr << "Property " << name << " is read-only" << endl;
}

const char *InternalFunctionProperty::GetValue(void) {
  if(getter)
    return getter(object);
  else {
    cerr << "Property " << name << " is write-only" << endl;
    return NULL;
  }
}

bool InternalFunctionProperty::IsReadOnly(void) {
  return (setter == NULL);
}
