/***************************************************************************
  internalfunctionproperty.h - property object that uses getter/setter functions
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__INTERNALFUNCTIONPROPERTY_H
#define INCLUDED__INTERNALFUNCTIONPROPERTY_H

#include "customobject.h"
#include "customproperty.h"

using namespace std;

class InternalFunctionProperty: public CustomProperty {
  public:
    InternalFunctionProperty(const char *name, ebCustomObject *object, propertygetfn getter, propertysetfn setter, bool required);
    void SetValue(const char *value);
    const char *GetValue(void);
    virtual bool IsReadOnly(void);
  private:
    propertygetfn getter;
    propertysetfn setter;
    ebCustomObject *object;
};

#endif
