/***************************************************************************
                 labelwidget.h  -  eboxy static label widget
                             -------------------
    begin                : Tue May 13 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__LABELWIDGET_H
#define INCLUDED__LABELWIDGET_H

#include "widgets.h"
   
class LabelWidget: public ebWidget {
  public:
    LabelWidget(const char *name, int x, int y, int w, int h, const char *text, FontEntry *font);
    virtual ~LabelWidget(void);
    GUI_Widget *Instantiate(void);
    void SetText(const char *text);
    char *GetText(void);
    void SetFont(FontEntry *font);
    void SetFontColor(SDL_Color c);
    void SetAutoSize(bool autosize);
    void SetAlign(int align);
    void SetWordWrap(bool wordwrap);
  private:
    char *text;
    FontEntry *font;
    int fontsize;
    SDL_Color fontcolor;
    int align;
    bool wordwrap;
    bool autosize;
    void DrawText(char *str, SDL_Rect *sr, SDL_Rect *dr);

    friend const char *LabelWidget_GetCaption(ebCustomObject *sender);
    friend void LabelWidget_SetCaption(ebCustomObject *sender, const char *value);
    friend const char *LabelWidget_GetFont(ebCustomObject *sender);
    friend void LabelWidget_SetFont(ebCustomObject *sender, const char *value);
    friend const char *LabelWidget_GetFontSize(ebCustomObject *sender);
    friend void LabelWidget_SetFontSize(ebCustomObject *sender, const char *value);
    friend const char *LabelWidget_GetFontColor(ebCustomObject *sender);
    friend void LabelWidget_SetFontColor(ebCustomObject *sender, const char *value);
    friend const char *LabelWidget_GetTextAlign(ebCustomObject *sender);
    friend void LabelWidget_SetTextAlign(ebCustomObject *sender, const char *value);
    friend const char *LabelWidget_GetAutoSize(ebCustomObject *sender);
    friend void LabelWidget_SetAutoSize(ebCustomObject *sender, const char *value);
    friend const char *LabelWidget_GetWordWrap(ebCustomObject *sender);
    friend void LabelWidget_SetWordWrap(ebCustomObject *sender, const char *value);
};

#endif
