/***************************************************************************
                          main.h  -  header for symbols in main.cpp
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__MAIN_H
#define INCLUDED__MAIN_H

#include "dynamicobject.h"
#include "plugintypes.h"
#include "types.h"
   
// Functions defined in main.cpp
void SignalExit(void);
void SignalHide(void);
int switchPageEvent(const char *pagename);
int switchFileEvent(const char *filename, const char *pagename);
void nextWidgetEvent(void);
void prevWidgetEvent(void);
void acceptSelectionEvent(void);
int execute(char *command, bool threaded);
void executeHide(char *command);
bool checkName(const char *name);
bool checkFileExists(const char *filename);
ebDynamicObject *findPageObject(const char *name, const char *type);
ImageEntry *loadImage(const char *filename);
ImageEntry *loadImage(const char *filename, bool force);
FontEntry *loadFont(const char *filename, int size);
bool checkVersion(eboxy_version_info clientlibver, char *filename);
int performAction(const char *action);
const char *getAppVersion(void);

#endif
