/***************************************************************************
                 objcontainer.h  -  object container abstract class
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__OBJCONTAINER_H
#define INCLUDED__OBJCONTAINER_H

#include "dynamicobject.h"
   
// Other classes can inherit from this class in order to gain simple object container capabilities
class ObjectContainer: public NotifyObject {
  public:
    virtual ~ObjectContainer(void);
    void AddObject(ebDynamicObject *object);
    void AddUnownedObject(ebDynamicObject *object); // for adding objects such as plugins that are already owned/managed elsewhere
    virtual ebDynamicObject *FindObject(const char *name, const char *type);
    void ClearObjects(void);
    void RemoveObject(ebDynamicObject *object);
    void RemoveObjectsOwnedBy(void *ownerref);
    virtual void Notify(ebObject *obj);
  protected:
    vector<ebDynamicObject *> containedobjects;
};

#endif
