/***************************************************************************
                          page.h  -  eboxy page (not really a widget)
                             -------------------
    begin                : Tue May 13 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__PAGE_H
#define INCLUDED__PAGE_H

#include "widgets.h"
#include "objcontainer.h"

using namespace std;

class ebPage: public ebWidget, public ObjectContainer {
  public:
    ebPage(const char *name, int x, int y, int w, int h);
    virtual GUI_Widget *Instantiate(void);
    virtual void Uninstantiate(void);
    void AddWidget(ebWidget *widget);
    void RemoveWidget(ebWidget *widget);
    void SetBackground(ImageEntry *image);
    void FocusNextWidget(void);
    void FocusPreviousWidget(void);
    void FocusFirstWidget(void);
    ebWidget *GetFocusedWidget(void);
    void UpdateFocus(void);
    void SetFocus(ebWidget *widget);
    ebDynamicObject *FindObject(const char *name, const char *type);
    ebWidget *FindWidget(const char *name, const char *type);
    void InvalidateRect(SDL_Rect a);
    void OnShow(void);
  private:
  	char *name;
    ImageEntry *background;
    vector<ebWidget *> widgets;
    int focusedindex;

    friend const char *Page_GetWidgetCount(ebCustomObject *sender);
    
    friend const char *Page_AddWidget(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
    friend const char *Page_RemoveWidget(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
    friend const char *Page_GetWidget(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
};

#endif
