/***************************************************************************
                          processobject.cpp - process wrapper
                             -------------------
    begin                : Sun Oct 6 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <pthread.h>
#include <errno.h>

#include "processobject.h"

using namespace std;

// Execute thread function
void *exec_thread_function(void *arg);

Process::Process(const char *cmd) {
  this->cmd = strdup(cmd);
  this->done = false;
}

Process::~Process(void) {
  free(cmd);
}

int Process::Execute(void) {
  done = false;
  returncode = system(cmd);
  if(errno) {
    done = true;
    perror("execute");
    return -1;
  }
  done = true;
  return returncode;
}

int Process::ExecuteThreaded(void) {
  if(pthread_create(&exec_thread, NULL, exec_thread_function, (void *)this)) {
    cerr << "Failed to create exec thread" << endl;
    return -1;
  }
  return 0;
}

bool Process::IsDone(void) {
  return done;
}

int Process::GetReturnCode(void) {
  if(done)
    return returncode;
  else
    return -2;
}

void *exec_thread_function(void *arg) {
  return (void *)((Process *)arg)->Execute();
}

