/***************************************************************************
                scriptobject.cpp  -  eboxy script handling object
                             -------------------
    begin                : Sun Aug 4 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include <cstdlib>
#include <cstring>

#include "utils.h"
#include "script.h"
#include "scriptobject.h"

using namespace std;

// Variable defined in main.cpp
extern char *xmlFile;

// Function defined by the Bison-generated parser
void yyparse(void *parm);

Script::Script(const char *name, const char *code, int flags)
: ebObject(name) {
  this->code = strdup(code);
  this->lineoffset = 0;
  this->flags = flags;
}

Script::~Script(void) {
  free(code);
}

void Script::SetLineOffset(int line) {
  this->lineoffset = line;
}

int Script::Run(void) {
  // Thanks for the reentrant parser go to Pavel Kalugin, who in 1998
  // posted to comp.compilers explaining how to munge a C++ Flex parser together
  // with a Bison parser - and it works :)
  ScriptLexer *lexer = new ScriptLexer(code, flags);
  lexer->SetLineOffset(lineoffset);
  lexer->SetFileName(xmlFile);
  ParserExecutionContext *parser_context = new ParserExecutionContext(lexer);
  yyparse((void *)parser_context);
  delete parser_context;
  delete lexer;
  return 0;  // FIXME: return other values?
}

