/***************************************************************************
                          scrollbarwidget.h  -  eboxy scrollbar widget
                             -------------------
    begin                : Tue May 13 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__SCROLLBARWIDGET_H
#define INCLUDED__SCROLLBARWIDGET_H
 
using namespace std;

#include "widgets.h"

class ScrollBarWidget: public ebWidget {
  public:
    ScrollBarWidget(const char *name, int x, int y, int w, int h);
    virtual GUI_Widget *Instantiate(void);
    void SetBackgroundImage(ImageEntry *image);
    void SetBackgroundStyle(int style);
    void SetKnobImage(ImageEntry *image);
    void SetKnobFocusImage(ImageEntry *image);
    void SetValue(int value);
    void SetMaximum(int maximum);
    void SetMinimum(int minimum);
    void SetPageStep(int pagestep);
    void SetReversed(bool reversed);
    void Increment(void);
    void Decrement(void);
    void IncrementPage(void);
    void DecrementPage(void);
    void GotoStart(void);
    void GotoEnd(void);
    virtual void GotFocus(void);
    virtual void LostFocus(void);
  private:
    int value;
    int minimum;
    int maximum;
    int pagestep;
    bool reversed;
    ImageEntry *knob;
    ImageEntry *knobfocus;
    ImageEntry *background;
    int backgroundstyle;
    void OnChange(GUI_Object *sender);

    friend const char *ScrollBarWidget_GetBackground(ebCustomObject *sender);
    friend void ScrollBarWidget_SetBackground(ebCustomObject *sender, const char *value);
    friend const char *ScrollBarWidget_GetBackgroundStyle(ebCustomObject *sender);
    friend void ScrollBarWidget_SetBackgroundStyle(ebCustomObject *sender, const char *value);
    friend const char *ScrollBarWidget_GetKnob(ebCustomObject *sender);
    friend void ScrollBarWidget_SetKnob(ebCustomObject *sender, const char *value);
    friend const char *ScrollBarWidget_GetKnobFocus(ebCustomObject *sender);
    friend void ScrollBarWidget_SetKnobFocus(ebCustomObject *sender, const char *value);
    friend const char *ScrollBarWidget_GetValue(ebCustomObject *sender);
    friend void ScrollBarWidget_SetValue(ebCustomObject *sender, const char *value);
    friend const char *ScrollBarWidget_GetMaximum(ebCustomObject *sender);
    friend void ScrollBarWidget_SetMaximum(ebCustomObject *sender, const char *value);
    friend const char *ScrollBarWidget_GetMinimum(ebCustomObject *sender);
    friend void ScrollBarWidget_SetMinimum(ebCustomObject *sender, const char *value);
    friend const char *ScrollBarWidget_GetPageStep(ebCustomObject *sender);
    friend void ScrollBarWidget_SetPageStep(ebCustomObject *sender, const char *value);
    friend const char *ScrollBarWidget_GetReversed(ebCustomObject *sender);
    friend void ScrollBarWidget_SetReversed(ebCustomObject *sender, const char *value);
};

#endif
