/***************************************************************************
                     skinparser.h - XML skin file parser header
                             -------------------
    begin                : Thu Nov 7 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__SKINPARSER_H
#define INCLUDED__SKINPARSER_H
 
#include "libxml/xmlmemory.h"
#include "libxml/parser.h"

#include "widgets.h"
#include "pluginobject.h"

// Structs
enum TEMPLATE_TYPES {
  TT_BUTTON,
  TT_LABEL,
  TT_PICTURE,
  TT_LISTBOX,
  TT_SCROLLBAR,
  TT_TEXTFIELD,
  TT_TOGGLEBUTTON
};

struct GenericTemplate {
  char *name;
  int type;
  StringList attributes;
};

// Functions

int parseSkin(char *filename);
int parsePages(xmlDocPtr doc, xmlNodePtr node);
int parseSystem(xmlDocPtr doc, xmlNodePtr node);
int parseTemplates(xmlDocPtr doc, xmlNodePtr node);
ebPage *parsePage(xmlDocPtr doc, xmlNodePtr node);

ebWidget *parseWidget(xmlDocPtr doc, xmlNodePtr node);

void parseEvent(xmlDocPtr doc, xmlNodePtr node, ebDynamicObject *parent);
EventTemplate *parseEvent(xmlDocPtr doc, xmlNodePtr node);
TimerObject *parseTimer(xmlDocPtr doc, xmlNodePtr node);
Plugin *parsePlugin(xmlDocPtr doc, xmlNodePtr node);

void clearTemplates(void);

GenericTemplate *parseTemplate(xmlDocPtr doc, xmlNodePtr node);
GenericTemplate *findTemplate(const char *templatename);
int applyTemplate(ebWidget *widget, const char *templatename);

ebWidget *CreateWidget(const char *name, const char *type);

#endif
