/***************************************************************************
                          systemobject.h  -  global system object
                             -------------------
    begin                : Wed May 14 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__SYSTEMOBJECT_H
#define INCLUDED__SYSTEMOBJECT_H

#include "customobject.h"
#include "objcontainer.h"

class SystemObject: public ebCustomObject, public ObjectContainer {
  public:
    SystemObject(void);
    ~SystemObject(void);
    int FireSystemEvent(const char *event);
    void AutoStartTimers(void);
    void InitialisePlugins(void);
  private:
    vector<TimerObject *> timers;

    friend const char *SystemObject_GetScreenWidth(ebCustomObject *sender);
    friend const char *SystemObject_GetScreenHeight(ebCustomObject *sender);
    friend const char *SystemObject_GetCurrentFile(ebCustomObject *sender);
    friend const char *SystemObject_GetVersion(ebCustomObject *sender);
    friend const char *SystemObject_GetPageCount(ebCustomObject *sender);

    friend const char *SystemObject_Quit(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
    friend const char *SystemObject_FocusNext(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
    friend const char *SystemObject_FocusPrevious(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
    friend const char *SystemObject_SelectFocused(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
    friend const char *SystemObject_PrintPluginList(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
    friend const char *SystemObject_PerformAction(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
    friend const char *SystemObject_GetPage(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
};

#endif
