/***************************************************************************
                          textfieldwidget.h  -  eboxy textfield widget
                             -------------------
    begin                : Tue May 13 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__TEXTFIELDWIDGET_H
#define INCLUDED__TEXTFIELDWIDGET_H

#include "widgets.h"

using namespace std;
   
class TextFieldWidget: public ebWidget {
  public:
    TextFieldWidget(const char *name, int x, int y, int w, int h, FontEntry *font, SDL_Color fontcolor, int maxlength);
    virtual ~TextFieldWidget(void);
    virtual GUI_Widget *Instantiate(void);
    void Uninstantiate(void);
    void SendChar(char c);
    void Backspace(void);
    void DeleteCurrChar(void);
    void SetBackgroundImage(ImageEntry *image);
    void SetBackgroundFocusImage(ImageEntry *image);
    void SetBackgroundStyle(int style);
    void SetFont(FontEntry *font);
    void SetFontColor(SDL_Color c);
    void SetBorderX(int pixels);
    void SetBorderY(int pixels);
    void SendEvent(SDL_Event e);
    int GetCursorPos(void);
    void SetCursorPos(int pos);
    void SetText(const char *str);
    void InputDigit(int chr);
    const char *GetText(void);
    void GotFocus(void);
    void LostFocus(void);
  private:
    char *text;
    int maxlength;
    ImageEntry *background;
    ImageEntry *backgroundfocus;
    int backgroundstyle;
    FontEntry *font;
    int fontsize;
    SDL_Color fontcolor;
    int borderx;
    int bordery;
    void OnChange(GUI_Object *sender);
    int inpdigit;
    const char *inpdigitptr;
    SDL_TimerID inpdigit_timer;

    friend const char *TextFieldWidget_GetText(ebCustomObject *sender);
    friend void TextFieldWidget_SetText(ebCustomObject *sender, const char *value);
    friend const char *TextFieldWidget_GetFont(ebCustomObject *sender);
    friend void TextFieldWidget_SetFont(ebCustomObject *sender, const char *value);
    friend const char *TextFieldWidget_GetFontSize(ebCustomObject *sender);
    friend void TextFieldWidget_SetFontSize(ebCustomObject *sender, const char *value);
    friend const char *TextFieldWidget_GetFontColor(ebCustomObject *sender);
    friend void TextFieldWidget_SetFontColor(ebCustomObject *sender, const char *value);
    friend const char *TextFieldWidget_GetBackground(ebCustomObject *sender);
    friend void TextFieldWidget_SetBackground(ebCustomObject *sender, const char *value);
    friend const char *TextFieldWidget_GetBackgroundFocus(ebCustomObject *sender);
    friend void TextFieldWidget_SetBackgroundFocus(ebCustomObject *sender, const char *value);
    friend const char *TextFieldWidget_GetBackgroundStyle(ebCustomObject *sender);
    friend void TextFieldWidget_SetBackgroundStyle(ebCustomObject *sender, const char *value);
    friend const char *TextFieldWidget_GetMaxLength(ebCustomObject *sender);
    friend void TextFieldWidget_SetMaxLength(ebCustomObject *sender, const char *value);
    friend const char *TextFieldWidget_GetBorderX(ebCustomObject *sender);
    friend void TextFieldWidget_SetBorderX(ebCustomObject *sender, const char *value);
    friend const char *TextFieldWidget_GetBorderY(ebCustomObject *sender);
    friend void TextFieldWidget_SetBorderY(ebCustomObject *sender, const char *value);
    friend const char *TextFieldWidget_GetCursorPos(ebCustomObject *sender);
    friend void TextFieldWidget_SetCursorPos(ebCustomObject *sender, const char *value);
};

#endif
