/***************************************************************************
                      timer.h - object wrapper for SDL timer
                             -------------------
    begin                : Wed May 14 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__TIMER_H
#define INCLUDED__TIMER_H

#include "customobject.h"

class TimerObject: public ebCustomObject {
  public:
    TimerObject(const char *name, int interval, bool autostart);
    virtual ~TimerObject(void);
    void SetInterval(int interval);
    void SetEnabled(bool enable);
    void Fire(void);
    void AutoStart(void);
  private:
    int interval;
    SDL_TimerID timer_id;
    bool enabled;
    bool autostart;

    friend const char *TimerObject_GetInterval(ebCustomObject *sender);
    friend void TimerObject_SetInterval(ebCustomObject *sender, const char *value);
    friend const char *TimerObject_GetEnabled(ebCustomObject *sender);
    friend void TimerObject_SetEnabled(ebCustomObject *sender, const char *value);

    friend const char *TimerObject_Start(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
    friend const char *TimerObject_Stop(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
};

#endif
