/***************************************************************************
                       togglebuttonwidget.h  -  toggle button widget
                             -------------------
    begin                : Mon May 12 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__TOGGLEBUTTONWIDGET_H
#define INCLUDED__TOGGLEBUTTONWIDGET_H

#include "widgets.h"
   
class ToggleButtonWidget: public ebWidget, ActionObject {
  public:
    ToggleButtonWidget(const char *name, int x, int y, int w, int h);
    virtual ~ToggleButtonWidget(void);
    virtual GUI_Widget *Instantiate(void);
    virtual void Uninstantiate(void);
    void SetWidth(int value);
    void SetHeight(int value);
    void SetNormalImage(ImageEntry *image);
    void SetNormalFocusImage(ImageEntry *image);
    void SetCheckedImage(ImageEntry *image);
    void SetCheckedFocusImage(ImageEntry *image);
//X    void SetDisabledImage(ImageEntry *image);
/*X    void SetFont(FontEntry *font);
    void SetFontColor(const SDL_Color *c);
    void SetFontFocusColor(const SDL_Color *c);
    void SetFontDisabledColor(const SDL_Color *c);
    void SetFontPressedColor(const SDL_Color *c);
    void SetCaption(char *caption);
    void SetCaptionX(int value);
    void SetCaptionY(int value);
    void SetCaptionDropX(int value);
    void SetCaptionDropY(int value);*/
    void SetAction(const char *actionname);
    void SetEnabled(bool enabled);
    bool GetChecked(void);
    void SetChecked(bool checked);
//X    void SimulateClick(void);
    virtual void GotFocus(void);
    virtual void LostFocus(void);
    void Execute(void);
  private:
//X    char *caption;
    const char *action;
/*X    GUI_Label *captionlabel;
    FontEntry *font;
    SDL_Color *fontcolor;
    SDL_Color *fontfocuscolor;
    SDL_Color *fontdisabledcolor;
    SDL_Color *fontpressedcolor; */
    ImageEntry *normalimage;
    ImageEntry *normalfocusimage;
    ImageEntry *checkedimage;
    ImageEntry *checkedfocusimage;
//X    ImageEntry *disabledimage;
/*X    int captionx;
    int captiony;
    int captiondropx;
    int captiondropy; */
    bool enabled;
    bool checked;
    void OnClick(GUI_Object *sender);
//X    void UpdateLabelColor(GUI_Widget *widget);

    friend const char *ToggleButtonWidget_GetNormalImage(ebCustomObject *sender);
    friend void ToggleButtonWidget_SetNormalImage(ebCustomObject *sender, const char *value);
    friend const char *ToggleButtonWidget_GetNormalFocusImage(ebCustomObject *sender);
    friend void ToggleButtonWidget_SetNormalFocusImage(ebCustomObject *sender, const char *value);
    friend const char *ToggleButtonWidget_GetCheckedImage(ebCustomObject *sender);
    friend void ToggleButtonWidget_SetCheckedImage(ebCustomObject *sender, const char *value);
    friend const char *ToggleButtonWidget_GetCheckedFocusImage(ebCustomObject *sender);
    friend void ToggleButtonWidget_SetCheckedFocusImage(ebCustomObject *sender, const char *value);
    friend const char *ToggleButtonWidget_GetEnabled(ebCustomObject *sender);
    friend void ToggleButtonWidget_SetEnabled(ebCustomObject *sender, const char *value);
    friend const char *ToggleButtonWidget_GetChecked(ebCustomObject *sender);
    friend void ToggleButtonWidget_SetChecked(ebCustomObject *sender, const char *value);
};

#endif
