/***************************************************************************
                          widgets.h - eboxy widget class
                             -------------------
    begin                : Sun Dec 1 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__WIDGETS_H
#define INCLUDED__WIDGETS_H

#include "customobject.h"

class ebWidget: public ebCustomObject {
  public:
    ebWidget(const char *name, int x, int y);
    virtual ~ebWidget(void);
    virtual GUI_Widget *Instantiate(void) = 0;
    virtual void Uninstantiate(void);
    GUI_Widget *GetInstance(void);
    void SetParent(ebWidget *p);
    bool GetTabStop(void);
    void SetTabStop(bool value);
    void SetX(int value);
    void SetY(int value);
    void SetPosition(int x, int y);
    virtual void SetWidth(int value);
    virtual void SetHeight(int value);
    SDL_Rect GetArea(void);
    void Invalidate(void);
    void InvalidateArea(void);
    virtual void GotFocus(void);
    virtual void LostFocus(void);
    bool IsGUIFocused(void);
    bool IsEnabled(void);
    virtual void Clone(ebWidget *newwidget);

    friend const char *Widget_GetX(ebCustomObject *sender);
    friend void Widget_SetX(ebCustomObject *sender, const char *value);
    friend const char *Widget_GetY(ebCustomObject *sender);
    friend void Widget_SetY(ebCustomObject *sender, const char *value);
    friend const char *Widget_GetWidth(ebCustomObject *sender);
    friend void Widget_SetWidth(ebCustomObject *sender, const char *value);
    friend const char *Widget_GetHeight(ebCustomObject *sender);
    friend void Widget_SetHeight(ebCustomObject *sender, const char *value);

    friend const char *Widget_SetFocus(ebCustomObject *sender, const char *method, int numargs, const char *args[]);
  protected:
    int x;
    int y;
    int w;
    int h;
    bool tabstop;
    GUI_Widget *realwidget;
    ebWidget *parent;
    bool focused;
};

#endif
